/*
Tranform global list into indexes and utilize garbage collector.
*/


proc/WorldHello()
	world<<"Hello!"

world/proc/Hello()
	world<<"Howdy!"


world/mob=/mob/Attackable/Player

mob/Attackable
	Player
		icon='mob.dmi'
		var
			coolDowns=new/list
		verb
//			Random Examples of how to use.
			StopHelloVerb()
				set category = "Hello Verb"
				set name = "H-Stop"
				stopCALL(/world/proc/Hello,HALT=1)

			ResumeHelloVerb()
				set category = "Hello Verb"
				set name = "H-Resume"
				resumeCALL(/world/proc/Hello)


			HelloVerb()
				set category = "Hello Verb"
				set name = "H-Start"
				CALL(function=/world/proc/Hello,loop=10,delay=5)

			DelayStart()
				set category = "Delay Verb"
				set name = "D-Start"
				CALL(SRC=src,function="Test",delay=10,arguments=list(B="B",A="A"))

			DelayStop()
				set category = "Delay Verb"
				set name = "D-Stop"
				stopCALL(SRC=src,ID="Test",HALT=1)

			DelayResume()
				set category = "Delay Verb"
				set name = "D-Resume"
				resumeCALL(SRC=src,ID="Test")


			CounterVerb()
				set category = "Counter Verb"
				set name = "C-Start"
				CALL(SRC=src,function="Test",delay=10,loop=10,arguments=list(B="B",A="A"))

			StopCounterVerb()
				set category = "Counter Verb"
				set name = "C-Stop"
				stopCALL(SRC=src,ID="Test",HALT=0)

//			Example abilities

/*
This abilities were created to display the usefulness of this library. Truth be told,
these abilities may look nice, but are ultimately useless. As stated, they were created
souly to display how this library could be used.
*/
			Dash()
				set category = "Abilities"
				CALL(SRC=src,function="StepDir",delay=0,loop=10)

			Heal()
				set category = "Abilities"
				if(CheckAbility("Heal",50))
					return
				src.Healer()

			Mega_Heal()
				set category = "Abilities"
				if(CheckAbility("Mega Heal",200))
					return
				CALL(SRC=src,function="Healer",loop=5,delay=2)

			Instant_Cooldown()
				set category = "Abilities"
				if(CheckAbility("Instant Cooldown","checkOnly"))
					return
				var/Ab=input("Which ability do you wish to cooldown?") as null|anything in coolDowns
				if(Ab==null|| !(Ab in coolDowns))
					world<<"Force return."
					return
				if(CheckAbility("Instant Cooldown",100))
					return
				stopCALL(SRC=src,ID=Ab)
				coolDowns-=Ab

			Mana_Shotgun()
				set category = "Abilities"
				if(CheckAbility("Mana Shotgun",500))
					return
				var/list/Dirs=list(src.dir,turn(src.dir,45),turn(src.dir,-45))
				for(var/turf/T in range(src,10))
					if(get_dist(src,T)<10|| !(get_dir(src,T) in Dirs)||prob(50))
						continue
					missile(/obj/spellEffects/Mana_Orb/,src,T)//built in BYOND proc, strictly visual

			Mana_Nova()
				set category = "Abilities"
				if(CheckAbility("Mana Nova",1000))
					return
				useManaNova()
			Mana_Super_Nova()
				set category = "Abilities"
				if(CheckAbility("Mana Super Nova",6000))
					return
				CALL(SRC=src,function="useManaNova",loop=10,delay=3)

		proc
			useManaNova()
				for(var/turf/T in range(src,10))
					if(get_dist(src,T)<10)
						continue
					missile(/obj/spellEffects/Mana_Orb/,src,T)//built in BYOND proc, strictly visual

			CheckAbility(var/A,var/D)
				if(A in src.coolDowns)
					src<<"[A] is still cooling down."
					.=1
				else
					if(isnum(D))
						coolDowns+="[A]"
						CALL(SRC=src,ID="[A]",function="coolDown",delay=D,arguments=list("[A]"))
					.=0
				..()

			coolDown(var/Ability)
				src.coolDowns-=Ability

			Test(var/A,var/B)
				var/global/N
				if(N==null)
					N=0
				N++
				world<<"RAN! [N] [A] [B] [src]"

			Healer()
				var/list/Spot=range(src,10)
				for(var/v=1 to rand(10,20))
					var/turf/T=pick(Spot)
					Spot-=T
					missile(/obj/spellEffects/Heal/,T,src)//built in BYOND proc, strictly visual

			StepDir()
				var/obj/spellEffects/Streak/S=new
				S.loc=src.loc
				S.dir=src.dir
				spawn(10)//By turning the loc to null and having nothing reference to it
				//the object is removed by the trash collector.
					S.loc=null
				step(src,src.dir)


obj
	spellEffects
		icon='Spells.dmi'
		Heal
			icon_state="Heal"
		Mana_Orb
			icon_state="Mana Orb"
		Streak
			icon_state="Streak"

turf
	environment
		icon='turfs.dmi'
		Grass
			icon_state="Grass"
		Wall
			icon_state="Wall"
			density=1

/*
the script under world/New() is not
the best thing to add to your game. However,
because I didn't feel like finding a grass icon and it
only took 3 minutes to script, it'll do. I just urge you to not
apply it to your game.
*/

world/New()
	..()
	for(var/turf/environment/Grass/g in world)
		set background = 1
		if(prob(60))
			continue
		var/r = rand(10)
		if(r==0){continue}
		var/icon/i = new(g.icon,g.icon_state)
		var/RGB=rgb(r,r,r)
		var/addOrSub
		if(prob(50))
			addOrSub=ICON_ADD
		else
			addOrSub=ICON_SUBTRACT
		i.Blend(RGB,addOrSub)
		g.icon=i
