/*

The idea of this library is to allow dynamic control of proc's. This being, a way to
add delay to a proc but not allow multipul stack, and a way to loop any proc.

I will explain everything in full. As usual(for more recent libraries) this will be a
plug-n-play library. Meaning you can simply copy and paste it over into your game.

No credit needed, just hope someone finds it useful(becides myself).

Now, for something important concerning this library.

Because it uses hascall to check the availability of a proc/verb. In theory, it would
defiently be idea to use path bases. Especially for players. Meaning, don't simply lump
everything together. Define things as should be. I'm sure you'll find this will help keep
the Proc Controler running smoothly, and will also help your game run smooth.
Remember, lag is the product of poor practice. Nobody likes lag..

Example:

world/mob=/mob/Attackable/Player//This will define players as mob/Attackable/Player


mob/Attackable
	Player
		verb
			Example()
				world<<"This was just an example..."
		proc
			ApplyHUD()
				world<<"Another example.."
	NPC
		name="NPC"
	Monster
		name="MOSTER!"
	proc/Deathcheck()
		world<<"Another example.."
		..()
*/



var/Procs=new/list
/*
Now, I cropped everything into one list to help prevent what I warned against above.

Applying variables to base paths is also very poor practice. Only things that need it should
have it...

Now, honestly, I prefer a more personal way. This being a variable for each independent thing
that will recieve the CALL() proc at some point. However, the way used will work just the same.
*/

/*
Below you will see the Proc datum. This is used as a central controller. It has variables
applied to it that helps it to know what to run, how many times, and run it on what(if not
simply a path).

New() has an ugly set of arguements. I had desired simply using the variabl args then
running a for to create a more dynamic easy to alter way. However, BYOND was having problems
with the way I wanted it done. Another route was available then I realized un-neccessary loops
would probably create un-neccessary CPU usage. The New() proc will apply all defined variables
to the Proc datum. It is idea to use the CALL() proc with defined arguements. There are examples
below.
*/

//expireTime is what the trash collector uses to assure dormid Proc datums dont
//hang around too long. Currently, the time is set for thirty minutes.
//Keep in mind the the trash collector runs every expireTime+10
//So you don't want to drop this number too low.


#define expireTime 18000

Proc
	var
		ID
		function
		arguments
		delay
		loop
		delayFirst//For loops
		atom/SRC
		refTag
		canLoop
		timeStamp
		Dormid
		standAlone
	New(var/SRC,var/ID,var/function,var/delay,var/loop,var/delayFirst,var/arguments,var/refTag,var/Dormid)
		..()
		src.SRC=SRC
		if(isnull(SRC))
			standAlone=1
		src.ID=ID
		src.function=function
		src.delay=delay
		src.loop=loop
		src.delayFirst=delayFirst
		src.refTag=refTag
		src.arguments=arguments
		src.Dormid=Dormid
		src.timeStamp=world.time/*
		timeStamp is used to calculate time deducted when a delay is set to dormid.*/
		if(isnum(loop))
			canLoop=1
		spawn()//This spawn was placed because for unknown reasons there would be a slight
			//delay between first and second run on a loop. Longer then intended
			// delay, that is.
			if(Dormid==1)
				return ..()
			src.procControle()
	Del()
		if(refTag in Procs)
			Procs-=refTag
		..()


/*
This library utilizes using datums and the built in call() proc.

datums are idea for information storage. This being they can be pathed as anything, cannot be
placed on map(so they don't take up as much memory), and initally have next to no variables.

So! If you need to store information in a dynamic way! Use a datum ;p
*/
	proc/procControle()
		set background=1//You "may" want to remove this. Although I'd suggest not to.
		//background being set will help prevent game lock-up from passive amounts of loops.
		//However, can cause abnormalities aswell. Odds of which are slim to none.
		if(!isnull(function))
			if(isnull(SRC)||hascall(SRC,function))
				if(isnull(SRC)&&standAlone!=1)
					del(src)
				Dormid=0
				if((delayFirst&&loop)||isnull(loop))
					sleep(delay)
					delayFirst=null
				if(SRC)
					call(SRC,function)(arglist(arguments))
				else
					call(function)(arglist(arguments))
				if(loop)
					if(isnum(loop))
						loop--
						if(loop<=0)
							del(src)
					spawn(delay)
						procControle()
					return
		del(src)

/*
I use my own version of a CALL() proc more or less to help control stacking, and the options
applied to the Proc datum.

*/

proc/CALL(var/SRC,var/ID,var/function,var/delay,var/loop,var/delayFirst,var/arguments,var/allowMulti,var/replace)
	var/REF="\ref[SRC][(ID?ID : function)]"
	if(REF in Procs)
		if(allowMulti!=1)
			if(replace!=1)
				return
			del(Procs[REF])
	Procs[REF]=new/Proc(SRC=SRC,ID=ID,loop=loop,function=function,delay=delay,delayFirst=delayFirst,arguments=arguments,refTag=REF)

/*
stopCall is designed to eliminate a loop or proc that hasn't been ran.

It will simply use referrence tags and ID/function to delete the datum. Once the datum is
deleted it will no longer have it's procControle() proc running.

if HALT is provided it will create a new /Proc/ that lies dormid and deletes the current.
This is idea for disabling loops or delayed procs. It can be triggered back on at
any given time using resumeCALL()
*/


proc/stopCALL(var/SRC,var/ID,var/HALT)
	if(isnull(ID))
		ID=SRC
		SRC=null
	var/REF="\ref[SRC][ID]"
	if(REF in Procs)
		if(HALT)
			var/Proc/P=Procs[REF]
			if(istype(P,/Proc/))
				if(P.loop==null)
					//This is the time-adjuster for delays that were hulted
					P.delay-=world.time-P.timeStamp
					if(P.delay<=0)
						del(Procs[REF])
				var/Proc/newP=new/Proc(SRC=P.SRC,ID=P.ID,loop=P.loop,function=P.function,delay=P.delay,delayFirst=P.delayFirst,arguments=P.arguments,refTag=P.refTag,Dormid=1)
				newP.canLoop=null
				del(Procs[REF])
				Procs[REF]=newP
			else
				del(Procs[REF])
		else
			del(Procs[REF])

/*
resumeCALL is used to trigger dormid proc's back active. I advise using this souly for loops.
However, with it's current scripting it can also be used on proc's that have a delayed start-up.
*/
proc/resumeCALL(var/SRC,var/ID)
	if(isnull(ID))
		ID=SRC
		SRC=null
	var/REF="\ref[SRC][ID]"
	if(REF in Procs)
		var/Proc/P=Procs[REF]
		if(istype(P,/Proc/))
			if(!P.canLoop)
				P.canLoop=1
				P.procControle()



/*
The way the procTrashCollector procedure works is first by looking at timestamps. Once it comes
to a Proc datum that has been made too recent, the trash collector stops. This being,
because things are added on a list oldest to newest, if it gets to one too recent the rest
can't possibly be too old.

Also, since this procedure will probably create some lag, it uses BYOND's built in
Trash Collector instead of manually deleting. So, a trash collector for a trash collector.
*/
world/proc/procTrashCollector(var/first)
	if(!first)
		for(var/v in Procs)
			set background = 5//This value may need to be altered. The thinking was if
			//lag was to kick in a larger wait would be desired.
			var/Proc/p = Procs[v]
			if(istype(p,/Proc/))
				if(world.time-p.timeStamp<expireTime)
					break
				if(p.SRC==null&&p.standAlone==null)
					Procs-=v
					continue
				if(p.Dormid==1&&world.time-p.timeStamp>=expireTime)
					Procs-=v
			else
				Procs-=v
	spawn(expireTime+100)
		world.procTrashCollector()


//Simple world/New() to start procTrashCollector(). Make sure to
//Have ..() in any existing world/New()'s already in your game or
//this will probably not be ran.

world/New()
	procTrashCollector(1)
	..()

